#include <bits/stdc++.h>

using namespace std;

int funkcija1(long long a[], long long n, long long b[], long long m)
{
        sort(a,a+n);
        long long  razlika=a[1]-a[0];
        for(int i=1; i<n-1; i++)
        {
           if((a[i+1]-a[i])%razlika!=0)
           {
               return 0;

           }


        }

            sort(b,b+m);
           for(int i=0; i<m; i++)
            {
                if(abs(b[i]-a[0])%razlika==0)
                {
                    return 0;

                }

            }
            return 1;

}

int main()
{
    long long t,ind=0;
    cin>>t;
    long long rez[t]={1};
    long long matrica[t][2];
    for(int j=0; j<t; j++)
    {

        cin>>matrica[j][0];
        cin>>matrica[j][1];
        long long  a[matrica[j][0]];
        long long b[matrica[j][1]];
        for(int i=0; i<matrica[j][0]; i++)
        {
            cin>>a[i];
        }
        for(int i=0; i<matrica[j][1];i++)
        {
            cin>>b[i];
        }
        rez[ind]=funkcija1(a,matrica[j][0],b,matrica[j][1]);
        ind++;


    }

    for(int i=0; i<t; i++)
    {
        cout<<rez[i]<<endl;
    }
    return 0;
}